#if !defined(AFX_ANALYZEDEMO_H__41507801_6F5D_11D2_8F2A_B6712CEBA7CD__INCLUDED_)
#define AFX_ANALYZEDEMO_H__41507801_6F5D_11D2_8F2A_B6712CEBA7CD__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "configdata.h"
#include "demodata.h"
#include "resultdata.h"

class analyzedemo  
{
public:
	analyzedemo(configdata* in_config, demodata* in_demo, resultdata* in_result);
	virtual ~analyzedemo();
private:
	void assign_origins();
	demodata_t* find_next_disconnect (demodata_t* pos, int player_id);
	demodata_t* find_end_of_demo (demodata_t* pos);
	demodata_t* find_next_death (demodata_t* pos, int player_id);
	demodata_t* find_next_playerspawn (demodata_t * pos, char* playername);
	error* err;
	misc* str;
	configdata* config;
	demodata* demo;
	resultdata* result;
	bool	all_kills_found;
	int		kill_count;
	void	get_players(); // only before result::freeze
	void	get_kills(); // only after result::freeze
	void	get_player_mkiol(); // only after result::freeze and this::get_kills
	void	get_player_quad(); // only after result::freeze and this::get_kills
	void	get_player_times();
	void	get_total_time();
	void	get_demo_count();
	void	get_demos();
	void	get_teams_lmctf();
	void	get_teams_battle();
	void	get_players_log(killtext_t* killmessage, int type);
	void	test_for_msg (killtext_t* killmessage, int type);
	void	count_kill (int player1, int player2, int type, int weapon, demodata_t* message);
	void	log_kill (int killer, int victim, int weapon, demodata_t* message);
	char*	killmsg_front (char* front, killtext_t* killmessage);
	char*	killmsg_middle (char* middle, killtext_t* killmessage); 
	char*	killmsg_back (char* back, killtext_t* killmessage);
};

#endif // !defined(AFX_ANALYZEDEMO_H__41507801_6F5D_11D2_8F2A_B6712CEBA7CD__INCLUDED_)
